import java.awt.*;
import java.awt.geom.*;

public class CBomb extends CKillable
{
  public static final int WIDTH = 16;
  public static final int HEIGHT = 16;
  public CBomb(CWorld world, Vector pos, Vector vel, Vector acc)
  {
    super(world, pos, vel, acc);
    hitBox = new Rectangle((int)pos.x()-WIDTH/2, (int)pos.y()-HEIGHT/2, WIDTH, HEIGHT);
    health = 1;
    leftImg = getImage("bomb.png");
  }
  
  public void createExplosion()
  {
    world.addThing(new CDoodad(world, pos, new Vector(), new Vector()));
  }
  
  public void die()
  {
    createExplosion();
    world.removeThing(this);
  }
  
  public void draw(Graphics g)
  { 
    g.setColor(Color.BLACK);
    //g.fillOval((int)pos.x()-WIDTH/2, (int)(world.getHeight()-pos.y())-HEIGHT/2, WIDTH, HEIGHT);
    g.drawImage(leftImg, (int)pos.x()-WIDTH/2, (int)(world.getHeight()-pos.y())-HEIGHT/2, null);
    //g.drawRect(hitBox.x, (int)(world.getHeight()-hitBox.y-hitBox.height), hitBox.width, hitBox.height);
  }
}