import java.awt.*;
import java.util.*;

class CBoss extends CPlane
{
  private static Random numGen = new Random();
  public int WIDTH = 150;
  public int HEIGHT = 75;
  private int bombDelay;
  private int buffness;
  
  public CBoss(CWorld world, Vector pos, Vector vel, Vector acc, int buffness)
  {
    super(world, pos, vel, acc);
    health = 500 + 40*buffness;

    leftImg = getImage("boss.gif");
    rightImg = getImage("boss.gif");
    hitBox = new Rectangle((int)pos.x()-WIDTH/2, (int)pos.y()-HEIGHT/2, WIDTH, HEIGHT);
    this.buffness = buffness;
    bombDelay = 0;
  }
  
  public void dropBombs()
  {
    Vector acc = new Vector(CWorld.GRAVITY);
    Vector newPos = new Vector(pos);
    newPos.addVector(new Vector(-50, 0));
    world.addThing(new CWavyBomb(world, newPos, new Vector(0,0), acc.scale(0.35)));
    newPos.addVector(new Vector(100, 0));
    world.addThing(new CWavyBomb(world, newPos, new Vector(0,0), acc));
  }
  
  public void update()
  {
    pos.addVector(vel);
    vel.addVector(acc);
    age++;
    
    hitBox.setLocation((int)pos.x()-hitBox.width/2, (int)pos.y()-hitBox.height/2);
        
    if(bombDelay == 0)
      dropBombs();
    
    bombDelay++;
    
    if(bombDelay == 18)
      bombDelay = 0;
    
    if(pos.x() < 50 || pos.x() > 800)
    {
      vel.scale(-1.0);
    }
  }
  
  public void draw(Graphics g)
  {
    g.setColor(Color.BLUE);
    if(vel.x() > 0)
      g.drawImage(rightImg, hitBox.x, (int)(world.getHeight()-hitBox.y-hitBox.height), null);
    else
      g.drawImage(leftImg, hitBox.x, (int)(world.getHeight()-hitBox.y-hitBox.height), null);
    
    //g.drawRect(hitBox.x, (int)(world.getHeight()-hitBox.y-hitBox.height), hitBox.width, hitBox.height);
  }
}