import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class CBuyMenu extends JPanel implements MouseListener
{
  private CWorld parent;
  private JButton bOk;
  private JButton bBuyChaffWeapon;
  private JButton bBuyLaserWeapon;
  private JButton bBuyMGunWeapon;
  private JButton bBuyRocketWeapon;
  private JButton bRestoreHealth;
  private JButton bBuyRockets;
  private JTextArea text;
  
  public CBuyMenu(CWorld parent)
  {
    this.parent = parent;


    bBuyMGunWeapon = addButton("Machine Gun");
    bBuyRocketWeapon = addButton("Rocket Launcher");
    bBuyChaffWeapon = addButton("Flak Launcher");
    bBuyLaserWeapon = addButton("Laser Cannon");
    bRestoreHealth = addButton("Restore health");
    text = new JTextArea("");
    text.setOpaque(false);
    text.setEnabled(false);
    text.setPreferredSize(new Dimension(750, 300));
    text.setAlignmentX(Component.CENTER_ALIGNMENT);
    Font f = new Font("Verdana", Font.PLAIN, 15);
    text.setFont(f);
    add(text);
    bOk = addButton("OK");
    
    bBuyMGunWeapon.addMouseListener(this);
    bBuyRocketWeapon.addMouseListener(this);
    bBuyChaffWeapon.addMouseListener(this);
    bBuyLaserWeapon.addMouseListener(this);
    bRestoreHealth.addMouseListener(this);
    bOk.addMouseListener(this);
  }
  
  public void display()
  {
    parent.add(Box.createVerticalStrut(100), BorderLayout.NORTH);
    parent.add(Box.createVerticalStrut(100), BorderLayout.SOUTH);
    parent.add(Box.createHorizontalStrut(100), BorderLayout.WEST);
    parent.add(Box.createHorizontalStrut(100), BorderLayout.EAST);
    parent.add(this, BorderLayout.CENTER);
    validate();
  }
  
  public JButton addButton(String text)
  {
    JButton button = new JButton(text);
    button.addActionListener(parent);
    add(button);
    return button;
  }

  public void hide()
  {
    parent.remove(this);
    validate();
  }
  
  protected static ImageIcon createImageIcon(String path)
  {
    java.net.URL imgURL = CBuyMenu.class.getResource(path);
    if (imgURL != null) {
      return new ImageIcon(imgURL);
    } else {
      System.err.println("Couldn't find file: " + path);
      return null;
    }
  }
  
  public void paintComponent(Graphics g)
  {
    super.paintComponent(g);
    g.setColor(new Color(0, 0, 50));
    g.fillRect(0,0,getWidth(), getHeight());
  }
  
  public void setText(String text)
  {
    this.text.setText(text);
  }
  
  public void mousePressed(MouseEvent m) {}
  public void mouseReleased(MouseEvent m) {}
  public void mouseEntered(MouseEvent m)
  {
    JButton source = (JButton)m.getSource();
    if(source == bBuyMGunWeapon)
    {
      String s = "\n\nThe Machine gun\nCost: [Default weapon]\n\nDescription:\n";
        s += "    Muon Tech's DC3750 heavy machine gun fires projectiles at a rate of 8 rounds per second.\n";
        s += "Its heavy 102.9mm projectiles travel in a parabolic trajectory and its sensitivity to changes\n";
        s += "in power and orientation makes it a difficult weapon to control.";
      setText(s);
    }
    else if(source == bBuyRocketWeapon && source.getText().equals("Rocket Launcher"))
    {
      String s = "\n\nBuy Rocket launcher\nCost: 5,000\n\nDescription:\n";
        s += "    The ALR-20 \"Valkyrie\" rocket launcher fires about 4 rockets per second.\n";
        s += "Each rocket has a Fuze-II onboard flight control system which adjusts its trajectory twice every\n";
        s += "millisecond to achieve extreme precision.  Each rocket is powered by a C&H rocket engine and\n";
        s += "contains a payload of one LMR tactical nuclear warhead and also has a secondary explosion of\n";
        s += "8 heavy 102.9mm projectiles.\n";
      setText(s);
    }
    else if(source == bBuyRocketWeapon && source.getText().equals("Buy rockets"))
    {
      String s = "\n\nBuy rockets\nCost: 1,000 for 50\n\nDescription:\n";
        s += "    The ALR-20 \"Valkyrie\" rocket launcher fires about 4 rockets per second.\n";
        s += "Each rocket has a Fuze-II onboard flight control system which adjusts its trajectory twice every\n";
        s += "millisecond to achieve extreme precision.  Each rocket is powered by a C&H rocket engine and\n";
        s += "contains a payload of one LMR tactical nuclear warhead and also has a secondary explosion of\n";
        s += "8 heavy 102.9mm projectiles.\n";
      setText(s);
    }
    else if(source == bBuyChaffWeapon && source.getText().equals("Flak Launcher"))
    {
      String s = "\n\nBuy Flak launcher\nCost: 7,500\n\nDescription:\n";
        s += "    The Artorius A-13F2 flak launcher fires about 2.77 projectiles per second.\n";
        s += "Every projectile has an accelerometer which detects downward acceleration and impact,\n";
        s += "which triggers the projectile's detonation.  Each high-energy explosion damages ALL nearby\n";
        s += "objects and lasts for a little less than 1 second.\n";
      setText(s);
    }
    else if(source == bBuyChaffWeapon && source.getText().equals("Buy mortars"))
    {
      String s = "\n\nBuy mortars\nCost: 1,500 for 50\n\nDescription:\n";
        s += "    The Artorius A-13F2 flak launcher fires about 2.77 projectiles per second.\n";
        s += "Every projectile has an accelerometer which detects downward acceleration and impact,\n";
        s += "which triggers the projectile's detonation.  Each high-energy explosion damages ALL nearby\n";
        s += "objects and lasts for a little less than 1 second.\n";
      setText(s);
    }
    else if(source == bBuyLaserWeapon)
    {
      String s = "\n\nBuy Laser Cannon\nCost: 15,000\n\nDescription:\n";
        s += "    The experimental X11 laser has an extremely high rate fire of 8.33 twin beams per second.\n";
        s += "The radon gas used in the laser creates a high-energy bolt which is powerful enough to\n";
        s += "vaporize small objects without any significant loss in power.  Normally, the laser requires\n";
        s += "an external power source, but in this situation the laser is linked to the shield's energy supply.\n";
        s += "Because of this, an additional load is placed on the energy systems of the bunker to fire the laser.\n";
      setText(s);
    }
    else if(source == bRestoreHealth)
    {
      String s = "\n\nRepair all damage\nCost: 1,500\n\nDescription:\n";
        s += "    Repairs all damage to your bunker.\n";
        setText(s);
    }
  }
  public void mouseExited(MouseEvent m) { setText(""); }
  public void mouseClicked(MouseEvent m) {}
  
  public void setRocketLauncherBought()
  {
    bBuyRocketWeapon.setText("Buy rockets");
  }
  
  public void setFlakLauncherBought()
  {
    bBuyChaffWeapon.setText("Buy mortars");
  }
}