import java.awt.*;
import java.awt.geom.*;
import javax.swing.*;
import java.net.URL;

public class CGameObject
{
  protected Vector pos;
  protected Vector vel;
  protected Vector acc;
  protected int age;
  protected CWorld world;
  protected Image leftImg;
  protected Image rightImg;
  
  /*public CGameObject()
   {
   world = null;
   pos = vel = acc = null;
   }*/
  public CGameObject(CWorld world, Vector pos, Vector vel, Vector acc)
  {
    this.world = world;
    spawn(pos, vel, acc);
  }
  
  public void draw(Graphics g)
  {
    g.setColor(Color.RED);
    g.fillOval((int)pos.x()-5, (int)(world.getHeight()-pos.y())-5, 10, 10);
  }
  
  public void update()
  {
    pos.addVector(vel);
    vel.addVector(acc);
    age++;
    
    if(world.outOfBounds(pos) == true)
      world.removeThing(this);
  }
  
  public void die()
  {
    world.removeThing(this);
  }
  
  public void spawn()
  {
    spawn(new Vector(), new Vector(), new Vector());
  }
  
  void spawn(Vector pos, Vector vel, Vector acc)
  {
    this.pos = new Vector(pos);
    this.vel = new Vector(vel);
    this.acc = new Vector(acc);
    
    age = 0;
  }
  
  public Vector getPos()
  {
    return pos;
  }
  
  public Vector getVel()
  {
    return vel;
  }
  
  public Vector getAcc()
  {
    return acc;
  }
  
  /**
   * Gets an image in the current working directory.
   * 
   * @param fileName File name of the image.
   * */
  Image getImage(String fileName)
  {
    URL imageURL = getClass().getClassLoader().getResource(fileName);
    if(imageURL == null) { return null; }
    return new ImageIcon(imageURL).getImage();
  }
}