import java.awt.*;
import java.util.*;

class CPlane extends CKillable
{
  private int waitTime;  // How long before the plane turns around after leaving
                         // the screen
  private static Random numGen = new Random();
  public int WIDTH = 63;
  public int HEIGHT = 50;
  
  public CPlane(CWorld world, Vector pos, Vector vel, Vector acc)
  {
    super(world, pos, vel, acc);
    health = 40;
    waitTime = 0;

    if(numGen.nextInt(2) == 1)
    {
      leftImg = getImage("arbiterLeft.png");
      rightImg = getImage("arbiterRight.png");
      WIDTH = 63;
      HEIGHT = 50;
    }
    else
    {
      leftImg = getImage("valkyrieLeft.png");
      rightImg = getImage("valkyrieRight.png");
      WIDTH = 52;
      HEIGHT = 41;
    }
    hitBox = new Rectangle((int)pos.x()-WIDTH/2, (int)pos.y()-HEIGHT/2, WIDTH, HEIGHT);
  }
  
  public void dropBombs()
  {
    Vector v = new Vector(vel);
    Vector acc = new Vector(CWorld.GRAVITY);
    world.addThing(new CBomb(world, pos, v.scale(0.75), acc.scale(0.2)));
    world.addThing(new CBomb(world, pos, v.scale(0.5), acc.scale(1.3)));
    world.addThing(new CBomb(world, pos, v.scale(-1.0), acc.scale(1.2)));
  }
  
  public void update()
  {
    pos.addVector(vel);
    vel.addVector(acc);
    age++;
    
    hitBox.setLocation((int)pos.x()-hitBox.width/2, (int)pos.y()-hitBox.height/2);
        
    if(numGen.nextInt(150) == 42)
      dropBombs();
    
    if(world.outOfBounds(pos) == true && waitTime < 60)
    {
      waitTime++;
    }
    else if(world.outOfBounds(pos) == true && waitTime >= 60)
    {
      vel.scale(-1.0);
      waitTime = 0;
    }
  }
  
  public void draw(Graphics g)
  {
    g.setColor(Color.BLUE);
    if(vel.x() > 0)
      g.drawImage(rightImg, hitBox.x, (int)(world.getHeight()-hitBox.y-hitBox.height), null);
    else
      g.drawImage(leftImg, hitBox.x, (int)(world.getHeight()-hitBox.y-hitBox.height), null);
    
    //g.drawRect(hitBox.x, (int)(world.getHeight()-hitBox.y-hitBox.height), hitBox.width, hitBox.height);
  }
}