import java.awt.*;
import java.awt.geom.*;

public class CWavyBomb extends CBomb
{
  public static final int WIDTH = 16;
  public static final int HEIGHT = 16;
  private int cycleCounter;
  
  public CWavyBomb(CWorld world, Vector pos, Vector vel, Vector acc)
  {
    super(world, pos, vel, acc);
    hitBox = new Rectangle((int)pos.x()-WIDTH/2, (int)pos.y()-HEIGHT/2, WIDTH, HEIGHT);
    health = 1;
    leftImg = getImage("bomb.png");
    cycleCounter = 0;
  }
  
  public void createExplosion()
  {
    world.addThing(new CDoodad(world, pos, new Vector(), new Vector()));
  }
  
  public void die()
  {
    createExplosion();
    world.removeThing(this);
  }
  
  public void draw(Graphics g)
  { 
    g.setColor(Color.BLACK);
    //g.fillOval((int)pos.x()-WIDTH/2, (int)(world.getHeight()-pos.y())-HEIGHT/2, WIDTH, HEIGHT);
    g.drawImage(leftImg, (int)pos.x()-WIDTH/2, (int)(world.getHeight()-pos.y())-HEIGHT/2, null);
    //g.drawRect(hitBox.x, (int)(world.getHeight()-hitBox.y-hitBox.height), hitBox.width, hitBox.height);
  }
  
  public void update()
  {
    super.update();
    hitBox.setLocation((int)pos.x()-hitBox.width/2, (int)pos.y()-hitBox.height/2);
    
    if(cycleCounter == 0)
      vel.addVector(new Vector(1.5, 0));
    else if(cycleCounter == 8)
      vel.addVector(new Vector(-1.5, 0));
    
    cycleCounter++;
    if(cycleCounter == 16)
      cycleCounter = 0;
  }
}