public class Vector
{
  private double x;
  private double y;
  
  public Vector(double x, double y)
  {
    this.x = x;
    this.y = y;
  }
  
  public Vector(int x, int y)
  {
    this.x = (double)x;
    this.y = (double)y;
  }
  
  public Vector()
  {
    this(0, 0);
  }
  
  public Vector(Vector v)
  {
    x = v.x();
    y = v.y();
  }
  
  public double length()
  {
    return Math.sqrt(x*x + y*y);
  }
  
  public void setLength(double length)
  {
    x *= length/length();
    y *= length/length();
  }
  
  public void rotate(double radians)
  {
    x = length() * Math.cos(angle() + radians);
    y = length() * Math.sin(angle() + radians);
  }
  
  public void setAngle(double radians)
  {
    x = length() * Math.cos(radians);
    y = length() * Math.sin(radians);
  }
  
  public double angle()
  {
    if(x == 0)
    {
      if(y > 0)
        return Math.PI/2;
      else
        return -Math.PI/2;
    }
    if(x > 0)
      return Math.atan(y/x);
    
    return Math.atan(y/x)+Math.PI;
  }
  
  public double x()
  {
    return x;
  }
  
  public double y()
  {
    return y;
  }
  
  public void setX(double x)
  {
    this.x = x;
  }
  
  public void setY(double y)
  {
    this.y = y;
  }
  
  public Vector unitVector()
  {
    return new Vector(x / length(), y / length());
  }
  
  public Vector scale(double ratio)
  {
    x *= ratio;
    y *= ratio;
    
    return this;
  }
  
  public void addVector(Vector v)
  {
    x += v.x();
    y += v.y();
  }
}